------------------------------------------------+
library ieee;
use ieee.std_logic_1164.all;
------------------------------------------------+
entity  RAM_1024x8bit is

Port (  DATA:           in  std_logic_vector(7 downto 0);
        ADDR:           in  integer range 0 to 1023;
		R0W1:           in  std_logic;
		Clk:            in  std_logic;
		DATAo:          out std_logic_vector(7 downto 0));

end RAM_1024x8bit;
------------------------------------------------+
architecture G of RAM_1024x8bit is
--=============================================================
	type DISPLAY is array (0 to 1023) of  std_logic_vector (7 downto 0);    
	signal RAM:  DISPLAY;
    signal ADDR_reg :      integer range 0 to 1023  := 0;
--=============================================================
BEGIN

-----------------
process (Clk)
begin
if Clk'event and Clk = '1' then
--=============================================================
if R0W1 = '1'  then RAM(ADDR) <= DATA;
               end if;
ADDR_reg <= ADDR;
--=============================================================
end if;
end process;
------------------

DATAo <= RAM(ADDR_reg);

end architecture G;