------------------------------------------------+
library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;
use std.standard.all;
------------------------------------------------+
entity  Arial_5x8_2047x8bit is

Port (  ADDR:           in  integer range 0 to 2047;
		Clk:            in  std_logic;
		DATA:           out unsigned(7 downto 0));

end Arial_5x8_2047x8bit;
------------------------------------------------+
architecture G of Arial_5x8_2047x8bit is
--=============================================================
	--Arial 5x8pt
	type SHRIFT is array (0 to 2047) of unsigned (7 downto 0);
	signal Arial:  SHRIFT:= (
    x"00",x"00",x"00",x"00",x"00", 
    x"00",x"00",x"00",x"00",x"00", 
    x"00",x"00",x"00",x"00",x"00", 
    x"00",x"00",x"00",x"00",x"00", 
    x"00",x"00",x"00",x"00",x"00", 
    x"00",x"00",x"00",x"00",x"00", 
    x"00",x"00",x"00",x"00",x"00", 
    x"00",x"00",x"00",x"00",x"00", 
    x"00",x"00",x"00",x"00",x"00", 
    x"00",x"00",x"00",x"00",x"00", 
    x"00",x"00",x"00",x"00",x"00", 
    x"00",x"00",x"00",x"00",x"00", 
    x"00",x"00",x"00",x"00",x"00", 
    x"00",x"00",x"00",x"00",x"00", 
    x"00",x"00",x"00",x"00",x"00", 
    x"00",x"00",x"00",x"00",x"00", 
    x"00",x"00",x"00",x"00",x"00", 
    x"00",x"00",x"00",x"00",x"00", 
    x"00",x"00",x"00",x"00",x"00", 
    x"00",x"00",x"00",x"00",x"00", 
    x"00",x"00",x"00",x"00",x"00", 
    x"00",x"00",x"00",x"00",x"00", 
    x"00",x"00",x"00",x"00",x"00", 
    x"00",x"00",x"00",x"00",x"00", 
    x"00",x"00",x"00",x"00",x"00", 
    x"00",x"00",x"00",x"00",x"00", 
    x"00",x"00",x"00",x"00",x"00", 
    x"00",x"00",x"00",x"00",x"00", 
    x"00",x"00",x"00",x"00",x"00", 
    x"00",x"00",x"00",x"00",x"00", 
    x"00",x"00",x"00",x"00",x"00", 
    x"00",x"00",x"00",x"00",x"00", 
    x"00",x"00",x"00",x"00",x"00", --пробел
    x"00",x"00",x"4f",x"00",x"00", --!
    x"00",x"07",x"00",x"07",x"00", --"
    x"14",x"7f",x"14",x"7f",x"14", --#
    x"24",x"2a",x"7f",x"2a",x"12", --$
    x"23",x"13",x"08",x"64",x"62", --%
    x"36",x"49",x"55",x"22",x"40", --&
    x"00",x"05",x"03",x"00",x"00", --,
    x"00",x"1c",x"22",x"41",x"00", --(
    x"00",x"41",x"22",x"1c",x"00", --)
    x"14",x"08",x"3E",x"08",x"14", --*
    x"08",x"08",x"3E",x"08",x"08", --+
    x"00",x"50",x"30",x"00",x"00", --,
    x"08",x"08",x"08",x"08",x"08", ---
    x"00",x"60",x"60",x"00",x"00", --.
    x"20",x"10",x"08",x"04",x"02", --/
    x"3e",x"51",x"49",x"45",x"3e", --0
    x"00",x"42",x"7f",x"40",x"00", --1
    x"42",x"61",x"51",x"49",x"46", --2
    x"21",x"41",x"45",x"4b",x"31", --3
    x"18",x"14",x"12",x"7f",x"10", --4
    x"27",x"45",x"45",x"45",x"39", --5
    x"3c",x"4a",x"49",x"49",x"30", --6
    x"01",x"71",x"09",x"05",x"03", --7
    x"36",x"49",x"49",x"49",x"36", --8
    x"06",x"49",x"49",x"29",x"1e", --9
    x"00",x"36",x"36",x"00",x"00", --:
    x"00",x"56",x"36",x"00",x"00", --;
    x"08",x"14",x"22",x"41",x"00", --<
    x"14",x"14",x"14",x"14",x"14", --=
    x"00",x"41",x"22",x"14",x"08", -->
    x"02",x"01",x"51",x"09",x"06", --?
    x"32",x"49",x"71",x"41",x"3e", --@
    x"7e",x"11",x"11",x"11",x"7e", --A
    x"7f",x"49",x"49",x"49",x"36", --B
    x"3e",x"41",x"41",x"41",x"22", --C
    x"7f",x"41",x"41",x"22",x"1c", --D
    x"7f",x"49",x"49",x"49",x"41", --E
    x"7f",x"09",x"09",x"09",x"01", --F
    x"3e",x"41",x"49",x"49",x"3a", --G
    x"7f",x"08",x"08",x"08",x"7f", --H
    x"00",x"41",x"7f",x"41",x"00", --I
    x"20",x"40",x"41",x"3f",x"01", --J
    x"7f",x"08",x"14",x"22",x"41", --K
    x"7f",x"40",x"40",x"40",x"40", --L
    x"7f",x"02",x"0c",x"02",x"7f", --M
    x"7f",x"04",x"08",x"10",x"7f", --N
    x"3e",x"41",x"41",x"41",x"3e", --O
    x"7f",x"09",x"09",x"09",x"06", --P
    x"3e",x"41",x"51",x"21",x"5e", --Q
    x"7f",x"09",x"19",x"29",x"46", --R
    x"46",x"49",x"49",x"49",x"31", --S
    x"01",x"01",x"7f",x"01",x"01", --T
    x"3f",x"40",x"40",x"40",x"3f", --U
    x"1f",x"20",x"40",x"20",x"1f", --V
    x"3f",x"40",x"70",x"40",x"3f", --W
    x"63",x"14",x"08",x"14",x"63", --X
    x"07",x"08",x"70",x"08",x"07", --Y
    x"61",x"51",x"49",x"45",x"43", --Z
    x"00",x"7F",x"41",x"41",x"00", --[
    x"02",x"04",x"08",x"10",x"20", --\ 
    x"00",x"41",x"41",x"7F",x"00", --]
    x"04",x"02",x"01",x"02",x"04", --^
    x"40",x"40",x"40",x"40",x"40", --_      
    x"00",x"01",x"02",x"04",x"00", --'
    x"20",x"54",x"54",x"54",x"78", --a
    x"7F",x"48",x"44",x"44",x"38", --b
    x"38",x"44",x"44",x"44",x"20", --c
    x"38",x"44",x"44",x"48",x"7F", --d
    x"38",x"54",x"54",x"54",x"18", --e
    x"08",x"7E",x"09",x"01",x"02", --f
    x"0C",x"52",x"52",x"52",x"3E", --g
    x"7F",x"08",x"04",x"04",x"78", --h
    x"00",x"44",x"7D",x"40",x"00", --i
    x"20",x"40",x"44",x"3D",x"00", --j
    x"7F",x"10",x"28",x"44",x"00", --k
    x"00",x"41",x"7F",x"40",x"00", --l
    x"7C",x"04",x"18",x"04",x"78", --m
    x"7C",x"08",x"04",x"04",x"78", --n
    x"38",x"44",x"44",x"44",x"38", --o
    x"7C",x"14",x"14",x"14",x"08", --p
    x"08",x"14",x"14",x"18",x"7C", --q
    x"7C",x"08",x"04",x"04",x"08", --r
    x"48",x"54",x"54",x"54",x"20", --s
    x"04",x"3F",x"44",x"40",x"20", --t
    x"3C",x"40",x"40",x"20",x"7C", --u
    x"1C",x"20",x"40",x"20",x"1C", --v
    x"3C",x"40",x"30",x"40",x"3C", --w
    x"44",x"28",x"10",x"28",x"44", --x
    x"0C",x"50",x"50",x"50",x"3C", --y
    x"44",x"64",x"54",x"4C",x"44", --z
    x"00",x"08",x"36",x"41",x"00", --{
    x"00",x"00",x"7f",x"00",x"00", --|
    x"00",x"41",x"36",x"08",x"00", --}
    x"02",x"01",x"02",x"02",x"01", --~
    x"00",x"00",x"00",x"00",x"00", 
    x"00",x"00",x"00",x"00",x"00", 
    x"00",x"00",x"00",x"00",x"00", 
    x"00",x"00",x"00",x"00",x"00", 
    x"00",x"00",x"00",x"00",x"00", 
    x"00",x"00",x"00",x"00",x"00", 
    x"00",x"00",x"00",x"00",x"00", 
    x"00",x"00",x"00",x"00",x"00", 
    x"00",x"00",x"00",x"00",x"00", 
    x"00",x"00",x"00",x"00",x"00", 
    x"00",x"00",x"00",x"00",x"00", 
    x"00",x"00",x"00",x"00",x"00", 
    x"00",x"00",x"00",x"00",x"00", 
    x"00",x"00",x"00",x"00",x"00", 
    x"00",x"00",x"00",x"00",x"00", 
    x"00",x"00",x"00",x"00",x"00", 
    x"00",x"00",x"00",x"00",x"00", 
    x"00",x"00",x"00",x"00",x"00", 
    x"00",x"00",x"00",x"00",x"00", 
    x"00",x"00",x"00",x"00",x"00", 
    x"00",x"00",x"00",x"00",x"00", 
    x"00",x"00",x"00",x"00",x"00", 
    x"00",x"00",x"00",x"00",x"00", 
    x"00",x"00",x"00",x"00",x"00", 
    x"00",x"00",x"00",x"00",x"00", 
    x"00",x"00",x"00",x"00",x"00", 
    x"00",x"00",x"00",x"00",x"00", 
    x"00",x"00",x"00",x"00",x"00", 
    x"00",x"00",x"00",x"00",x"00", 
    x"00",x"00",x"00",x"00",x"00", 
    x"00",x"00",x"00",x"00",x"00", 
    x"00",x"00",x"00",x"00",x"00", 
    x"00",x"00",x"00",x"00",x"00", 
    x"00",x"00",x"00",x"00",x"00", 
    x"00",x"00",x"00",x"00",x"00", 
    x"00",x"00",x"00",x"00",x"00", 
    x"00",x"00",x"00",x"00",x"00", 
    x"00",x"00",x"00",x"00",x"00", 
    x"00",x"00",x"00",x"00",x"00", 
    x"00",x"00",x"00",x"00",x"00", 
    x"00",x"00",x"00",x"00",x"00", 
    x"00",x"00",x"00",x"00",x"00", 
    x"00",x"00",x"00",x"00",x"00", 
    x"00",x"00",x"00",x"00",x"00", 
    x"00",x"00",x"00",x"00",x"00", 
    x"00",x"00",x"00",x"00",x"00", 
    x"00",x"00",x"00",x"00",x"00", 
    x"00",x"00",x"00",x"00",x"00", 
    x"00",x"00",x"00",x"00",x"00", 
    x"00",x"00",x"00",x"00",x"00", 
    x"00",x"00",x"00",x"00",x"00", 
    x"00",x"00",x"00",x"00",x"00", 
    x"00",x"00",x"00",x"00",x"00", 
    x"00",x"00",x"00",x"00",x"00", 
    x"00",x"00",x"00",x"00",x"00", 
    x"00",x"00",x"00",x"00",x"00", 
    x"00",x"00",x"00",x"00",x"00", 
    x"00",x"00",x"00",x"00",x"00", 
    x"00",x"00",x"00",x"00",x"00", 
    x"00",x"00",x"00",x"00",x"00", 
    x"00",x"00",x"00",x"00",x"00", 
    x"00",x"00",x"00",x"00",x"00", 
    x"00",x"00",x"00",x"00",x"00", 
    x"00",x"00",x"00",x"00",x"00", 
    x"AA",x"55",x"AA",x"55",x"AA", --резерв
    x"7e",x"11",x"11",x"11",x"7e", --A
    x"7f",x"49",x"49",x"49",x"33", --Б
    x"7f",x"49",x"49",x"49",x"36", --В
    x"7f",x"01",x"01",x"01",x"03", --Г
    x"e0",x"51",x"4f",x"41",x"ff", --Д
    x"7f",x"49",x"49",x"49",x"41", --E
    x"77",x"08",x"7f",x"08",x"77", --Ж
    x"41",x"49",x"49",x"49",x"36", --З
    x"7f",x"10",x"08",x"04",x"7f", --И
    x"7c",x"21",x"12",x"09",x"7c", --Й
    x"7f",x"08",x"14",x"22",x"41", --K
    x"20",x"41",x"3f",x"01",x"7f", --Л
    x"7f",x"02",x"0c",x"02",x"7f", --M
    x"7f",x"08",x"08",x"08",x"7f", --H
    x"3e",x"41",x"41",x"41",x"3e", --O
    x"7f",x"01",x"01",x"01",x"7f", --П
    x"7f",x"09",x"09",x"09",x"06", --P
    x"3e",x"41",x"41",x"41",x"22", --C
    x"01",x"01",x"7f",x"01",x"01", --T
    x"47",x"28",x"10",x"08",x"07", --У
    x"1c",x"22",x"7f",x"22",x"1c", --Ф
    x"63",x"14",x"08",x"14",x"63", --X
    x"7f",x"40",x"40",x"40",x"ff", --Ц
    x"07",x"08",x"08",x"08",x"7f", --Ч
    x"7f",x"40",x"7f",x"40",x"7f", --Ш
    x"7f",x"40",x"7f",x"40",x"ff", --Щ
    x"01",x"7f",x"48",x"48",x"30", --Ъ
    x"7f",x"48",x"30",x"00",x"7f", --Ы
    x"00",x"7f",x"48",x"48",x"30", --Э
    x"22",x"41",x"49",x"49",x"3e", --Ь
    x"7f",x"08",x"3e",x"41",x"3e", --Ю
    x"46",x"29",x"19",x"09",x"7f", --Я 
    x"20",x"54",x"54",x"54",x"78", --a
    x"3c",x"4a",x"4a",x"49",x"31", --б
    x"7c",x"54",x"54",x"28",x"00", --в
    x"7c",x"04",x"04",x"04",x"0c", --г
    x"e0",x"54",x"4c",x"44",x"fc", --д
    x"38",x"54",x"54",x"54",x"18", --e
    x"6c",x"10",x"7c",x"10",x"6c", --ж
    x"44",x"44",x"54",x"54",x"28", --з
    x"7c",x"20",x"10",x"08",x"7c", --и
    x"7c",x"41",x"22",x"11",x"7c", --й
    x"7c",x"10",x"28",x"44",x"00", --к
    x"20",x"44",x"3c",x"04",x"7c", --л
    x"7c",x"08",x"10",x"08",x"7c", --м
    x"7c",x"10",x"10",x"10",x"7c", --н
    x"38",x"44",x"44",x"44",x"38", --o
    x"7c",x"04",x"04",x"04",x"7c", --п
    x"7C",x"14",x"14",x"14",x"08", --p 
    x"38",x"44",x"44",x"44",x"20", --c
    x"04",x"04",x"7c",x"04",x"04", --т
    x"0C",x"50",x"50",x"50",x"3C", --у
    x"30",x"48",x"fc",x"48",x"30", --ф
    x"44",x"28",x"10",x"28",x"44", --x
    x"7c",x"40",x"40",x"40",x"fc", --ц
    x"0c",x"10",x"10",x"10",x"7c", --ч
    x"7c",x"40",x"7c",x"40",x"7c", --ш
    x"7c",x"40",x"7c",x"40",x"fc", --щ
    x"04",x"7c",x"50",x"50",x"20", --ъ
    x"7c",x"50",x"50",x"20",x"7c", --ы
    x"7c",x"50",x"50",x"20",x"00", --ь
    x"28",x"44",x"54",x"54",x"38", --э
    x"7c",x"10",x"38",x"44",x"38", --ю
    x"08",x"54",x"34",x"14",x"7c", --я
    others => x"00");
--=============================================================
	signal RomData:                     unsigned (7 downto 0):= x"00";
    signal RomAddress:                  integer range 0 to 2047;
    signal ADDR_reg :      integer range 0 to 2047  := 0;
--=============================================================
BEGIN

-----------------
process (Clk)
begin
if Clk'event and Clk = '1' then
--=============================================================
DATA <= Arial(ADDR);
--=============================================================
end if;
end process;
------------------


end architecture G;